%Bayer CFA demosaicking using frequency domain method for stripe pattern
%Run on all images in Kodak dataset and save MSE, CPSNR values
clear all;close all;
root = 'H:\documents\draft\demosiacking\matlab\originals\';  
tic
for i = 1:24
    if i <= 9 
        filename=strcat(root,sprintf('0%.0f',i),'.tif');
    else 
        filename=strcat(root,sprintf('%.0f',i),'.tif');
    end
    ORIG = im2double(imread(filename));
    CFA = create_stripe_CFA(ORIG);  %Create stripe mosaicked image
    OUT = demos_freq_stripe(CFA);  % apply frequency domain method 
    imwrite(OUT,strcat(root,'results\stripe\',sprintf('0%.0f',i),'_adapt.tif'));
%    imwrite(OUT,strcat(root,'results\stripe\',sprintf('0%.0f',i),'_adapt.jpg'),'quality',90);
% Compute MSE for each component and color PSNR
b = 6; % border size
[MSE_R(i) MSE_G(i) MSE_B(i) CPSNR(i)] = cpsnr_calc(ORIG,OUT,b);
end
toc
%statistics
mean_R = mean(MSE_R); std_R = std(MSE_R);
mean_G = mean(MSE_G); std_G = std(MSE_G);
mean_B = mean(MSE_B); std_B = std(MSE_B);
mean_CPSNR = mean(CPSNR); std_CPSNR = std(CPSNR);
%Gunturk image numbers
num = 1:24;
Gnum=[1 2 0 0 3 4 5 6 7 8 9 10 11 0 12 13 14 15 16 17 18 19 0 20];
%display results
s = '   Kodak #   Gunturk #    MSE_R    MSE_G     MSE_B    CPSNR'
results = [[num 0 0]' [Gnum 0 0]' [MSE_R mean_R std_R]' [MSE_G mean_G std_G]'...
    [MSE_B mean_B std_B]' [CPSNR mean_CPSNR std_CPSNR]']
save 'errors_freq_stripe_LS_Kodak' results;